package com.artfess.form.param;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * 生成表单默认实体模板参数
 *
 * @company 阿特菲斯信息技术有限公司
 * @author:zhangxw
 * @date:2020年8月21日
 */
@ApiModel(description = "生成表单默认模板参数")
public class TemplateEntParam {

    @ApiModelProperty(name = "id", notes = "实体Id")
    private String id;

    @ApiModelProperty(name = "alias", notes = "实体别名")
    private String alias;

    @ApiModelProperty(name = "name", notes = "实体名称")
    private String name;

    @ApiModelProperty(name = "type", notes = "类型（main:主表，sub：子表，sun：孙表）")
    private String type;

    @ApiModelProperty(name = "template", notes = "模板")
    private String template;

    @ApiModelProperty(name = "column", notes = "列数")
    private Integer column = 2;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getAlias() {
        return alias;
    }

    public void setAlias(String alias) {
        this.alias = alias;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getTemplate() {
        return template;
    }

    public void setTemplate(String template) {
        this.template = template;
    }

    public Integer getColumn() {
        return column;
    }

    public void setColumn(Integer column) {
        this.column = column;
    }

}
